/******************************************************************************
 *    pydefs.h
 *
 *    This file is part of PyNumbra
 *    Copyright (C) 2004 Tom N Harris <telliamed@whoopdedo.cjb.net>
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *****************************************************************************/

/******************************************
 * Various defines for dealing with Python
 */

#if DEBUG
// Change the Python #defines into functions so debugging is more sensical
// 

#if __GNUC__

#undef Py_DECREF
inline void Py_DECREF(PyObject *op)
{
	if (--op->ob_refcnt != 0)
		;
	else 
		_Py_Dealloc(op);
}

#undef Py_XDECREF
inline void Py_XDECREF(PyObject *op)
{
	if ((op) == NULL) ;
	else
		if (--op->ob_refcnt != 0)
			;
		else 
			_Py_Dealloc(op);
}

#endif

#endif

#if (PY_VERSION_HEX < 0x02030000)
// Python 2.3

#error PyNumbra requires Python 2.3 or later

#endif

