#include <windows.h>
#include <winnt.h>

#include "allhacks.h"

extern void* const* hackDromed1_132;
extern void* const* hackDromed2_118;
extern void* const* hackShocked2_212;
extern void* const* hackThief2_118;

static void* const* globalHackTable = NULL;

/* bit 31 = set if editor, bit 16-23 = game version (1,2,3),
   bit 8-15 = app major version, bit 0-8 = app minor version
 */
static DWORD globalAppVersion = 0;

static unsigned long globalVMAAdjustment = 0;

struct _time_and_size { DWORD timestamp; DWORD codesize; DWORD version; };
static const struct _time_and_size _hacks[] = {
	{ 0xFFFFFFFF, 0xFFFFFFFF, 0 },
	{ 0x36A4EF7F, 0x26B200, 0x80010120 },
	{ 0x38DFAC00, 0x2AF000, 0x80020112 },
	{ 0x37B0944F, 0x2ECE00, 0x8003020C },
	{ 0x38DFB97A, 0x1FF000, 0x00020112 }
};

static int GrokDromedVersion(void)
{
	const char* base;
	const IMAGE_NT_HEADERS * image;
	DWORD timestamp, codesize;
	int n;

	base = (char*)GetModuleHandle(NULL);
	if ((unsigned long)base != 0x400000)
		globalVMAAdjustment = (unsigned long)base - 0x400000;
	
	base += ((PIMAGE_DOS_HEADER)base)->e_lfanew;
	image = (PIMAGE_NT_HEADERS)base;
	if (image->Signature != IMAGE_NT_SIGNATURE)
		return 0;
	timestamp = image->FileHeader.TimeDateStamp;
	codesize = image->OptionalHeader.SizeOfCode;
	n = sizeof(_hacks)/sizeof(_hacks[0]) - 1;
	while (n)
	{
		if (_hacks[n].timestamp == timestamp && _hacks[n].codesize == codesize)
			break;
		--n;
	}
	globalAppVersion = _hacks[n].version;

	return n;
}


BOOL WINAPI DllMain(HINSTANCE hInst, DWORD dwReason, LPVOID pReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		switch (GrokDromedVersion())
		{
		case 1:
			globalHackTable = hackDromed1_132;
			break;
		case 2:
			globalHackTable = hackDromed2_118;
			break;
		case 3:
			globalHackTable = hackShocked2_212;
			break;
		case 4:
			globalHackTable = hackThief2_118;
		default:
			return FALSE;
		}
		return TRUE;
	}
	return TRUE;
}


__declspec(dllexport) __stdcall 
void* GetDromedProcAddress(DWORD dwProcIndex)
{
	if (!globalHackTable || dwProcIndex >= __LAST_SYMBOL)
		return NULL;
	if (globalVMAAdjustment != 0 && globalHackTable[dwProcIndex] != NULL)
	{
		return (void*)((unsigned long)globalHackTable[dwProcIndex] + globalVMAAdjustment);
	}
	return globalHackTable[dwProcIndex];
}

__declspec(dllexport) __stdcall 
DWORD GetDromedVersion(void)
{
	return globalAppVersion;
}

__declspec(dllexport) __stdcall 
DWORD GetGameVersion(void)
{
	return (globalAppVersion >> 16) & 0xFF;
}

__declspec(dllexport) __stdcall 
BOOL IsEditor(void)
{
	return (globalAppVersion & 0x80000000) ? TRUE : FALSE;
}
